Index: trunk/src/wp-includes/script-loader.php
===================================================================
--- trunk/src/wp-includes/script-loader.php	(revision 44265)
+++ trunk/src/wp-includes/script-loader.php	(revision 44271)
@@ -91,4 +91,16 @@
 	);
 
+	$vendor_scripts_versions = array(
+		'react'                       => '16.6.3',
+		'react-dom'                   => '16.6.3',
+		'moment'                      => '2.22.2',
+		'lodash'                      => '4.17.11',
+		'wp-polyfill-fetch'           => '3.0.0',
+		'wp-polyfill-formdata'        => '3.0.12',
+		'wp-polyfill-node-contains'   => '3.26.0-0',
+		'wp-polyfill-element-closest' => '2.0.2',
+		'wp-polyfill'                 => '7.0.0',
+	);
+
 	foreach ( $vendor_scripts as $handle => $dependencies ) {
 		if ( is_string( $dependencies ) ) {
@@ -97,7 +109,8 @@
 		}
 
-		$path = "/wp-includes/js/dist/vendor/$handle$dev_suffix.js";
-
-		$scripts->add( $handle, $path, $dependencies, false, 1 );
+		$path    = "/wp-includes/js/dist/vendor/$handle$dev_suffix.js";
+		$version = $vendor_scripts_versions[ $handle ];
+
+		$scripts->add( $handle, $path, $dependencies, false, $version );
 	}
 
@@ -193,4 +206,45 @@
 function wp_default_packages_scripts( &$scripts ) {
 	$suffix = wp_scripts_get_suffix();
+
+	$packages_versions = array(
+		'api-fetch'                          => '2.2.5',
+		'a11y'                               => '2.0.2',
+		'annotations'                        => '1.0.3',
+		'api-fetch'                          => '2.2.5',
+		'autop'                              => '2.0.2',
+		'blob'                               => '2.1.0',
+		'block-library'                      => '2.2.6',
+		'block-serialization-default-parser' => '2.0.0',
+		'blocks'                             => '6.0.2',
+		'components'                         => '7.0.1',
+		'compose'                            => '3.0.0',
+		'core-data'                          => '2.0.14',
+		'data'                               => '4.0.1',
+		'date'                               => '3.0.0',
+		'deprecated'                         => '2.0.3',
+		'dom'                                => '2.0.7',
+		'dom-ready'                          => '2.0.2',
+		'edit-post'                          => '3.1.1',
+		'editor'                             => '9.0.1',
+		'element'                            => '2.1.8',
+		'escape-html'                        => '1.0.1',
+		'format-library'                     => '1.2.4',
+		'hooks'                              => '2.0.3',
+		'html-entities'                      => '2.0.3',
+		'i18n'                               => '3.1.0',
+		'is-shallow-equal'                   => '1.1.4',
+		'keycodes'                           => '2.0.5',
+		'list-reusable-blocks'               => '1.1.14',
+		'notices'                            => '1.1.0',
+		'nux'                                => '3.0.2',
+		'plugins'                            => '2.0.9',
+		'redux-routine'                      => '3.0.3',
+		'rich-text'                          => '3.0.2',
+		'shortcode'                          => '2.0.2',
+		'token-list'                         => '1.1.0',
+		'url'                                => '2.3.1',
+		'viewport'                           => '2.0.12',
+		'wordcount'                          => '2.0.3',
+	);
 
 	$packages_dependencies = array(
@@ -245,5 +299,4 @@
 		),
 		'block-serialization-default-parser' => array(),
-		'block-serialization-spec-parser'    => array( 'wp-polyfill' ),
 		'components'                         => array(
 			'lodash',
@@ -412,8 +465,9 @@
 
 	foreach ( $packages_dependencies as $package => $dependencies ) {
-		$handle = 'wp-' . $package;
-		$path   = "/wp-includes/js/dist/$package$suffix.js";
-
-		$scripts->add( $handle, $path, $dependencies, false, 1 );
+		$handle  = 'wp-' . $package;
+		$path    = "/wp-includes/js/dist/$package$suffix.js";
+		$version = $packages_versions[ $package ];
+
+		$scripts->add( $handle, $path, $dependencies, false, $version );
 
 		if ( isset( $package_translations[ $package ] ) ) {