Index: /trunk/package-lock.json
===================================================================
--- /trunk/package-lock.json	(revision 46869)
+++ /trunk/package-lock.json	(revision 46870)
@@ -2057,272 +2057,17 @@
 		},
 		"@wordpress/block-directory": {
-			"version": "1.1.0",
-			"resolved": "https://registry.npmjs.org/@wordpress/block-directory/-/block-directory-1.1.0.tgz",
-			"integrity": "sha512-4q/7wQmyypFWWEht7GdhRzCR5Y3R0LjmHAOJvfVxrFUop/PT4MSJf7T3Sqt5+ebQH6Z9JztePJ0R6m82nnA41g==",
-			"requires": {
-				"@wordpress/api-fetch": "^3.7.0",
-				"@wordpress/block-editor": "^3.3.0",
-				"@wordpress/blocks": "^6.8.0",
-				"@wordpress/components": "^8.4.0",
-				"@wordpress/compose": "^3.8.0",
-				"@wordpress/data": "^4.10.0",
-				"@wordpress/element": "^2.9.0",
-				"@wordpress/i18n": "^3.7.0",
-				"@wordpress/plugins": "^2.8.0",
+			"version": "1.0.6",
+			"resolved": "https://registry.npmjs.org/@wordpress/block-directory/-/block-directory-1.0.6.tgz",
+			"integrity": "sha512-0UjGG0zr7CRxxsZXkPM9p8uKxx3cKEfPhX7q0QzN+IDNg5W7rplrlfdouGfmFGnqO1IsbGphkvwlen6KNfHGSg==",
+			"requires": {
+				"@wordpress/api-fetch": "^3.6.4",
+				"@wordpress/block-editor": "^3.2.5",
+				"@wordpress/blocks": "^6.7.2",
+				"@wordpress/components": "^8.3.2",
+				"@wordpress/compose": "^3.7.2",
+				"@wordpress/data": "^4.9.2",
+				"@wordpress/element": "^2.8.2",
+				"@wordpress/i18n": "^3.6.1",
 				"lodash": "^4.17.15"
-			},
-			"dependencies": {
-				"@wordpress/api-fetch": {
-					"version": "3.7.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/api-fetch/-/api-fetch-3.7.0.tgz",
-					"integrity": "sha512-D5RsDNZDMqPAZXE8ffXJpO5lG/C1nyOmsLFGyYMinxoPLNaXkXN9zFv6R/Afp31DJk4h2c8S1ynyc4FJg1bFrw==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/i18n": "^3.7.0",
-						"@wordpress/url": "^2.8.2"
-					}
-				},
-				"@wordpress/block-editor": {
-					"version": "3.3.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/block-editor/-/block-editor-3.3.0.tgz",
-					"integrity": "sha512-sB/3vGudfh8Wt2rvf5kU1Bcr8AS5mfnb+GaW9H5ux7S3YVneJWBc3JjflFwrLAyPl+YWVM89/WI6ViltAQ5m9w==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/a11y": "^2.5.1",
-						"@wordpress/blob": "^2.5.1",
-						"@wordpress/blocks": "^6.8.0",
-						"@wordpress/components": "^8.4.0",
-						"@wordpress/compose": "^3.8.0",
-						"@wordpress/data": "^4.10.0",
-						"@wordpress/deprecated": "^2.6.1",
-						"@wordpress/dom": "^2.6.0",
-						"@wordpress/element": "^2.9.0",
-						"@wordpress/hooks": "^2.6.0",
-						"@wordpress/html-entities": "^2.5.0",
-						"@wordpress/i18n": "^3.7.0",
-						"@wordpress/is-shallow-equal": "^1.6.1",
-						"@wordpress/keycodes": "^2.7.0",
-						"@wordpress/rich-text": "^3.8.0",
-						"@wordpress/token-list": "^1.7.0",
-						"@wordpress/url": "^2.8.2",
-						"@wordpress/viewport": "^2.9.0",
-						"@wordpress/wordcount": "^2.6.2",
-						"classnames": "^2.2.5",
-						"diff": "^3.5.0",
-						"dom-scroll-into-view": "^1.2.1",
-						"inherits": "^2.0.3",
-						"lodash": "^4.17.15",
-						"memize": "^1.0.5",
-						"react-autosize-textarea": "^3.0.2",
-						"react-spring": "^8.0.19",
-						"redux-multi": "^0.1.12",
-						"refx": "^3.0.0",
-						"rememo": "^3.0.0",
-						"tinycolor2": "^1.4.1",
-						"traverse": "^0.6.6"
-					}
-				},
-				"@wordpress/blocks": {
-					"version": "6.8.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/blocks/-/blocks-6.8.0.tgz",
-					"integrity": "sha512-reXx/x/PzMpl0oKu0DQt2UonEF1mi/5t+jBu4IXcZXZnL8fpdoU6HsHuRshbCaAN2bSL9gdrEUeUx4m7cYN+Gg==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/autop": "^2.5.1",
-						"@wordpress/blob": "^2.5.1",
-						"@wordpress/block-serialization-default-parser": "^3.4.1",
-						"@wordpress/compose": "^3.8.0",
-						"@wordpress/data": "^4.10.0",
-						"@wordpress/dom": "^2.6.0",
-						"@wordpress/element": "^2.9.0",
-						"@wordpress/hooks": "^2.6.0",
-						"@wordpress/html-entities": "^2.5.0",
-						"@wordpress/i18n": "^3.7.0",
-						"@wordpress/is-shallow-equal": "^1.6.1",
-						"@wordpress/shortcode": "^2.5.0",
-						"hpq": "^1.3.0",
-						"lodash": "^4.17.15",
-						"rememo": "^3.0.0",
-						"showdown": "^1.8.6",
-						"simple-html-tokenizer": "^0.5.7",
-						"tinycolor2": "^1.4.1",
-						"uuid": "^3.3.2"
-					}
-				},
-				"@wordpress/components": {
-					"version": "8.4.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/components/-/components-8.4.0.tgz",
-					"integrity": "sha512-Fr2L8b8RxUC6hPiN2pMVKGaeB25RA+g4ENpA32LzmuEGd0ITBXtZfFUv3+5FMcUe4y9KFQZbXxBRElBf4xA+SQ==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/a11y": "^2.5.1",
-						"@wordpress/compose": "^3.8.0",
-						"@wordpress/deprecated": "^2.6.1",
-						"@wordpress/dom": "^2.6.0",
-						"@wordpress/element": "^2.9.0",
-						"@wordpress/hooks": "^2.6.0",
-						"@wordpress/i18n": "^3.7.0",
-						"@wordpress/is-shallow-equal": "^1.6.1",
-						"@wordpress/keycodes": "^2.7.0",
-						"@wordpress/rich-text": "^3.8.0",
-						"classnames": "^2.2.5",
-						"clipboard": "^2.0.1",
-						"dom-scroll-into-view": "^1.2.1",
-						"lodash": "^4.17.15",
-						"memize": "^1.0.5",
-						"moment": "^2.22.1",
-						"mousetrap": "^1.6.2",
-						"re-resizable": "^6.0.0",
-						"react-dates": "^17.1.1",
-						"react-spring": "^8.0.20",
-						"rememo": "^3.0.0",
-						"tinycolor2": "^1.4.1",
-						"uuid": "^3.3.2"
-					}
-				},
-				"@wordpress/compose": {
-					"version": "3.8.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/compose/-/compose-3.8.0.tgz",
-					"integrity": "sha512-n22OFDcwoMZ+/GAjVCd28cwlN6NHslTy4eONLLS7tOrdMKYl4wQ3cFLzxu8XHgf1Pt14ogGyOaJqvdEGbBGrsw==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/element": "^2.9.0",
-						"@wordpress/is-shallow-equal": "^1.6.1",
-						"lodash": "^4.17.15"
-					}
-				},
-				"@wordpress/data": {
-					"version": "4.10.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/data/-/data-4.10.0.tgz",
-					"integrity": "sha512-MDab2ePxLDkBJQ/Dxw1oYHpRGEmDzublBgo5ShTEhfPu14zj5fJhq2mnO7uH3A7s93/a2ZyjSn4h2fc8QJvb6w==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/compose": "^3.8.0",
-						"@wordpress/deprecated": "^2.6.1",
-						"@wordpress/element": "^2.9.0",
-						"@wordpress/is-shallow-equal": "^1.6.1",
-						"@wordpress/priority-queue": "^1.3.1",
-						"@wordpress/redux-routine": "^3.6.2",
-						"equivalent-key-map": "^0.2.2",
-						"is-promise": "^2.1.0",
-						"lodash": "^4.17.15",
-						"redux": "^4.0.0",
-						"turbo-combine-reducers": "^1.0.2"
-					}
-				},
-				"@wordpress/dom": {
-					"version": "2.6.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/dom/-/dom-2.6.0.tgz",
-					"integrity": "sha512-ERti77Y7Y0Oix7jfvIvBRX6Jx7hTvg6k6ke6LmeuMo+V7g5abmNEHLU4tL/dGSLNw9/SShStTIPu9Vg2IL44WA==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"lodash": "^4.17.15"
-					}
-				},
-				"@wordpress/element": {
-					"version": "2.9.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/element/-/element-2.9.0.tgz",
-					"integrity": "sha512-IohEi9EkT+jnZof35l5PxDAHaBZXOcZzFS14B4cBt1eKFjbd5C54b8lHbifaL8b82S26ggMdA44sEoXVutdC0g==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/escape-html": "^1.6.0",
-						"lodash": "^4.17.15",
-						"react": "^16.9.0",
-						"react-dom": "^16.9.0"
-					}
-				},
-				"@wordpress/escape-html": {
-					"version": "1.6.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/escape-html/-/escape-html-1.6.0.tgz",
-					"integrity": "sha512-PD4fEg7qIB2l8+buuRmYJ5edQhvUzydu6XoCigV2G4rju3BI+MO57BcEZf1LSPfbrYqTJCca3ElNW9nNbSQthQ==",
-					"requires": {
-						"@babel/runtime": "^7.4.4"
-					}
-				},
-				"@wordpress/i18n": {
-					"version": "3.7.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/i18n/-/i18n-3.7.0.tgz",
-					"integrity": "sha512-yavu3yAKbSkEosQvEd0lCa064SdFFb8i6f7RfZGDq/TQfJHBaJQvRA4Hd/CtrOXqS6DLjw2rLNrVG4XcJFss1A==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"gettext-parser": "^1.3.1",
-						"lodash": "^4.17.15",
-						"memize": "^1.0.5",
-						"sprintf-js": "^1.1.1",
-						"tannin": "^1.1.0"
-					}
-				},
-				"@wordpress/keycodes": {
-					"version": "2.7.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/keycodes/-/keycodes-2.7.0.tgz",
-					"integrity": "sha512-FPOFKSPY5WrvQuNr1l/WYn/ey+NoRO+RKQTlGR2EgpfWonqVGpV+CfEVyvgPVj8BBVcQHVDJYGkNEKDsoZ5l+g==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/i18n": "^3.7.0",
-						"lodash": "^4.17.15"
-					}
-				},
-				"@wordpress/plugins": {
-					"version": "2.8.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/plugins/-/plugins-2.8.0.tgz",
-					"integrity": "sha512-FMGg6pWhpv5gYbIuh2dHJKvrTvlZjMrD89iQjy02YyNZCXfFWlW8uJ/Ffz2Srl2DNQ8fVtW68M0Fyh+MMO7QdA==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/compose": "^3.8.0",
-						"@wordpress/element": "^2.9.0",
-						"@wordpress/hooks": "^2.6.0",
-						"lodash": "^4.17.15"
-					}
-				},
-				"@wordpress/rich-text": {
-					"version": "3.8.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/rich-text/-/rich-text-3.8.0.tgz",
-					"integrity": "sha512-vvPNCq15g7FnS3/vT2n6F0efo32fmlEZWjgDA23mmUWyTXcMx0zPchCfRU7qGVrUm8Ht7wdKUilDkF7oMLt8Cg==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/compose": "^3.8.0",
-						"@wordpress/data": "^4.10.0",
-						"@wordpress/deprecated": "^2.6.1",
-						"@wordpress/element": "^2.9.0",
-						"@wordpress/escape-html": "^1.6.0",
-						"@wordpress/hooks": "^2.6.0",
-						"@wordpress/is-shallow-equal": "^1.6.1",
-						"@wordpress/keycodes": "^2.7.0",
-						"classnames": "^2.2.5",
-						"lodash": "^4.17.15",
-						"memize": "^1.0.5",
-						"rememo": "^3.0.0"
-					}
-				},
-				"@wordpress/shortcode": {
-					"version": "2.5.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/shortcode/-/shortcode-2.5.0.tgz",
-					"integrity": "sha512-8EUdOc1nUasIgbWRNCoLcJmB4a5iGPqiVtZLGMT238+BaK1DzfP/vrQw9V9UHl7OfdkEt0Dns9R49VhH/6EW+A==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"lodash": "^4.17.15",
-						"memize": "^1.0.5"
-					}
-				},
-				"@wordpress/token-list": {
-					"version": "1.7.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/token-list/-/token-list-1.7.0.tgz",
-					"integrity": "sha512-Qhn5mdgBYd3MH/65AgaNK6qu9+fWZJvsmdTgn5AFPVkREeCujz8FAkyvoQnblcrZC99ReCn1+cUeoLKQeyyz2w==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"lodash": "^4.17.15"
-					}
-				},
-				"@wordpress/viewport": {
-					"version": "2.9.0",
-					"resolved": "https://registry.npmjs.org/@wordpress/viewport/-/viewport-2.9.0.tgz",
-					"integrity": "sha512-rUkloEVS0bCKJdgQO6Xys714QXrgTs57qYG65XoN29wk9LBD6wLa+Xrj15lLJ+TzW7ZJr/Hk+J7cVxzTdl4Gbw==",
-					"requires": {
-						"@babel/runtime": "^7.4.4",
-						"@wordpress/compose": "^3.8.0",
-						"@wordpress/data": "^4.10.0",
-						"lodash": "^4.17.15"
-					}
-				}
 			}
 		},